if($Pref::Server::SuperAdminPassword $= "")
{
	error("Server_RemoteControl - You need to set a Super Admin password for this add-on to work. This is for security purposes.");
	return;
}
exec("./webserver.cs");
package Server_RemoteControl
{
	function disconnectedCleanup(%bool)
	{
		if(isObject($RemoteControl::Webserver))
			$RemoteControl::Webserver.delete();
		return parent::disconnectedCleanup(%bool);
	}
};
activatePackage(Server_RemoteControl);
%w = new FileObject();
%w.openForWrite("config/remote/accounts.dat");
%w.writeLine("#Remote control");
%w.writeLine("remote:" @ $Pref::Server::SuperAdminPassword);
%w.close();
%w.delete();
if(!isObject($RemoteControl::Webserver))
{
	$RemoteControl::Webserver = new TCPObject(Webserver)
	{
		port = $Pref::Server::Port;
		debug = false;
		localOnly = false;
		localIPs = "127.0.0.1 192.168. 10.0.";
		blockIPs = "";
		timeout = 1000;
		accounts = "config/remote/accounts.dat";
		folder = "Add-Ons/Server_RemoteControl/web";
		index = "/index.tqss";
		tagPrefix = "<?tqs ";
		tagSuffix = " ?>";
	};
	$RemoteControl::Webserver.listen($RemoteControl::Webserver.port);
}
$RemoteControl::Web::Prefs = 0;
function remoteControl_registerPref(%category,%name,%pref,%type,%callback)
{
	%id = "pref_" @ strReplace(strLwr(%name)," ","_");
	$RemoteControl::Web::Pref[$RemoteControl::Web::Prefs] = %category TAB %id TAB %name TAB %pref TAB %type TAB %callback;
	$RemoteControl::Web::PrefFromID[%id] = $RemoteControl::Web::Prefs;
	$RemoteControl::Web::IDFromPref[$RemoteControl::Web::Prefs] = %id;
	$RemoteControl::Web::Prefs++;
}
remoteControl_registerPref("General","Server Name","$Pref::Server::Name","string");
remoteControl_registerPref("General","Welcome Message","$Pref::Server::WelcomeMessage","string");
remoteControl_registerPref("General","Max Players","$Pref::Server::MaxPlayers","int");
remoteControl_registerPref("General","Server Password","$Pref::Server::Password","string");
remoteControl_registerPref("General","Admin Password","$Pref::Server::AdminPassword","string");
remoteControl_registerPref("General","E-Tard Filter","$Pref::Server::ETardFilter","bool");
remoteControl_registerPref("General","E-Tard Words","$Pref::Server::ETardList","string");
remoteControl_registerPref("General","Max Bricks per Second","$Pref::Server::MaxBricksPerSecond","int");
remoteControl_registerPref("General","Falling Damage","$Pref::Server::FallingDamage","bool");
remoteControl_registerPref("General","Wrench Events Admin Only","$Pref::Server::WrenchEventsAdminOnly","bool");
remoteControl_registerPref("General","Too Far Distance for Building","$Pref::Server::TooFarDistance","int");
function hex2dec(%value)
{
	%digits = "0123456789ABCDEFabcdef";
	%first = getSubStr(%value,0,1);
	%second = getSubStr(%value,1,1);
	%firsti = strPos(%digits,%first);
	if(%firsti >= 16)
		%firsti -= 6;
	%secondi = strpos(%digits,%second);
	if(%secondi >= 16)
		%secondi -= 6;
	if(%firsti < 0 || %secondi < 0)
		return 0;
	return %firsti * 16 + %secondi;
}
function urlDecodeCharAt(%value)
{
	if(%value < 32)
	{
		if(%value == 9)
			%value = 127;
		if(%value == 10)
			%value = 128;
		if(%value == 13)
			%value = 129;
	}
	%value = %value - 32;
	%table = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_'abcdefghijklmnopqrstuvwxyz{|}~tnr";
	return getSubStr(%table,%value,1);
}
function urlDecode(%encodeString)
{
	%rawString = "";
	%len = strLen(%encodeString);
	if(%len > 0)
	{
		for(%i=0;%i<%len;%i++)
		{
			%chrTemp = getSubStr(%encodeString,%i,1);
			if(%chrTemp $= "+")
			{
				%chrTemp = " ";
			}
			else if (%chrTemp $= "%")
			{
				%nextTwo = getSubStr(%encodeString,%i + 1,2);
				%i += 2;
				if(strLen(%nextTwo) < 2)
					break;
				%chrTemp = urlDecodeCharAt(hex2dec(%nextTwo));
			}
			%rawString = %rawString @ %chrTemp;
		}
	}
	return %rawString;
}
function addItemToList(%string,%item)
{
	if(hasItemOnList(%string,%item))
		return %string;

	if(%string $= "")
		return %item;
	else
		return %string SPC %item;
}
function hasItemOnList(%string,%item)
{
	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
			return 1;
	}
	return 0;
}
function removeItemFromList(%string,%item)
{
	if(!hasItemOnList(%string,%item))
		return %string;

	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
		{
			if(%i $= 0)
				return getWords(%string,1,getWordCount(%string));
			else if(%i $= getWordCount(%string)-1)
				return getWords(%string,0,%i-1);
			else
				return getWords(%string,0,%i-1) SPC getWords(%string,%i+1,getWordCount(%string));
		}
	}
}
